
using System;
using System.IO;
using System.Collections;



//-----------------------------------------------------------------------------------
// Scanner
//-----------------------------------------------------------------------------------
public partial class Scanner {

	const int maxT = 23;
	const int noSym = 23;


	static Scanner() {
		start = new Hashtable(128);
		for (int i = 65; i <= 68; ++i) start[i] = 1;
		for (int i = 70; i <= 90; ++i) start[i] = 1;
		for (int i = 97; i <= 104; ++i) start[i] = 1;
		for (int i = 106; i <= 122; ++i) start[i] = 1;
		for (int i = 48; i <= 57; ++i) start[i] = 3;
		start[69] = 12; 
		start[105] = 13; 
		start[Buffer.EOF] = -1;

	}
	
	void NextCh() {
		if (oldEols > 0) { ch = EOL; oldEols--; } 
		else {
			pos = buffer.Pos;
			ch = buffer.Read(); col++;
			// replace isolated '\r' by '\n' in order to make
			// eol handling uniform across Windows, Unix and Mac
			if (ch == '\r' && buffer.Peek() != '\n') ch = EOL;
			if (ch == EOL) { line++; col = 0; }
		}

	}

	void AddCh() {
		if (tlen >= tval.Length) {
			char[] newBuf = new char[2 * tval.Length];
			Array.Copy(tval, 0, newBuf, 0, tval.Length);
			tval = newBuf;
		}
		if (ch != Buffer.EOF) {
			tval[tlen++] = (char) ch;
			NextCh();
		}
	}



	bool Comment0() {
		int level = 1, pos0 = pos, line0 = line, col0 = col;
		NextCh();
			for(;;) {
				if (ch == 13) {
					level--;
					if (level == 0) { oldEols = line - line0; NextCh(); return true; }
					NextCh();
				} else if (ch == Buffer.EOF) return false;
				else NextCh();
			}
	}

	bool Comment1() {
		int level = 1, pos0 = pos, line0 = line, col0 = col;
		NextCh();
			for(;;) {
				if (ch == 10) {
					level--;
					if (level == 0) { oldEols = line - line0; NextCh(); return true; }
					NextCh();
				} else if (ch == Buffer.EOF) return false;
				else NextCh();
			}
	}

	bool Comment2() {
		int level = 1, pos0 = pos, line0 = line, col0 = col;
		NextCh();
		if (ch == '/') {
			NextCh();
			for(;;) {
				if (ch == 10) {
					level--;
					if (level == 0) { oldEols = line - line0; NextCh(); return true; }
					NextCh();
				} else if (ch == Buffer.EOF) return false;
				else NextCh();
			}
		} else {
			buffer.Pos = pos0; NextCh(); line = line0; col = col0;
		}
		return false;
	}

	bool Comment3() {
		int level = 1, pos0 = pos, line0 = line, col0 = col;
		NextCh();
		if (ch == '*') {
			NextCh();
			for(;;) {
				if (ch == '*') {
					NextCh();
					if (ch == '/') {
						level--;
						if (level == 0) { oldEols = line - line0; NextCh(); return true; }
						NextCh();
					}
				} else if (ch == '/') {
					NextCh();
					if (ch == '*') {
						level++; NextCh();
					}
				} else if (ch == Buffer.EOF) return false;
				else NextCh();
			}
		} else {
			buffer.Pos = pos0; NextCh(); line = line0; col = col0;
		}
		return false;
	}


	void CheckLiteral() {
		switch (t.val) {
			case "Result": t.kind = 3; break;
			case "Iterative": t.kind = 5; break;
			case "method": t.kind = 6; break;
			case "did": t.kind = 7; break;
			case "not": t.kind = 8; break;
			case "converge": t.kind = 9; break;
			case "within": t.kind = 10; break;
			case "Consider": t.kind = 12; break;
			case "using": t.kind = 13; break;
			case "a": t.kind = 14; break;
			case "different": t.kind = 15; break;
			case "numerical": t.kind = 16; break;
			case "or": t.kind = 17; break;
			case "increasing": t.kind = 18; break;
			case "the": t.kind = 19; break;
			case "maximum": t.kind = 20; break;
			case "number": t.kind = 21; break;
			case "of": t.kind = 22; break;
			default: break;
		}
	}

	Token NextToken() {
		while (ch == ' ' ||
			ch >= 9 && ch <= 10 || ch == 13
		) NextCh();
		if (ch == 'P' && Comment0() ||ch == 'P' && Comment1() ||ch == '/' && Comment2() ||ch == '/' && Comment3()) return NextToken();
		t = new Token();
		t.pos = pos; t.col = col; t.line = line; 
		int state;
		if (start.ContainsKey(ch)) { state = (int) start[ch]; }
		else { state = 0; }
		tlen = 0; AddCh();
		
		switch (state) {
			case -1: { t.kind = eofSym; break; } // NextCh already done
			case 0: { t.kind = noSym; break; }   // NextCh already done
			case 1:
				if (ch == '!' || ch >= '%' && ch <= '&' || ch == '+' || ch == '-' || ch >= '/' && ch <= '9' || ch == '=' || ch == '?' || ch >= 'A' && ch <= 'Z' || ch >= '^' && ch <= '_' || ch >= 'a' && ch <= 'z' || ch == 163 || ch == 167 || ch == 176 || ch == 231 || ch == 233) {AddCh(); goto case 2;}
				else {t.kind = 1; t.val = new String(tval, 0, tlen); CheckLiteral(); return t;}
			case 2:
				if (ch == '!' || ch >= '%' && ch <= '&' || ch == '+' || ch == '-' || ch >= '/' && ch <= '9' || ch == '=' || ch == '?' || ch >= 'A' && ch <= 'Z' || ch >= '^' && ch <= '_' || ch >= 'a' && ch <= 'z' || ch == 163 || ch == 167 || ch == 176 || ch == 231 || ch == 233) {AddCh(); goto case 2;}
				else {t.kind = 1; t.val = new String(tval, 0, tlen); CheckLiteral(); return t;}
			case 3:
				if (ch >= '0' && ch <= '9') {AddCh(); goto case 9;}
				else if (ch == 'E') {AddCh(); goto case 4;}
				else if (ch == ',' || ch == '.') {AddCh(); goto case 6;}
				else {t.kind = 2; break;}
			case 4:
				if (ch == '+' || ch == '-') {AddCh(); goto case 5;}
				else {t.kind = noSym; break;}
			case 5:
				if (ch >= '0' && ch <= '9') {AddCh(); goto case 5;}
				else {t.kind = 2; break;}
			case 6:
				if (ch >= '0' && ch <= '9') {AddCh(); goto case 7;}
				else {t.kind = noSym; break;}
			case 7:
				if (ch >= '0' && ch <= '9') {AddCh(); goto case 8;}
				else if (ch == 'E') {AddCh(); goto case 4;}
				else {t.kind = 2; break;}
			case 8:
				if (ch >= '0' && ch <= '9') {AddCh(); goto case 8;}
				else if (ch == 'E') {AddCh(); goto case 4;}
				else {t.kind = 2; break;}
			case 9:
				if (ch >= '0' && ch <= '9') {AddCh(); goto case 9;}
				else if (ch == 'E') {AddCh(); goto case 4;}
				else if (ch == ',' || ch == '.') {AddCh(); goto case 6;}
				else {t.kind = 2; break;}
			case 10:
				{t.kind = 4; break;}
			case 11:
				{t.kind = 11; break;}
			case 12:
				if (ch == '!' || ch >= '%' && ch <= '&' || ch == '+' || ch == '-' || ch >= '/' && ch <= '9' || ch == '=' || ch == '?' || ch >= 'A' && ch <= 'Z' || ch >= '^' && ch <= '_' || ch >= 'a' && ch <= 'q' || ch >= 's' && ch <= 'z' || ch == 163 || ch == 167 || ch == 176 || ch == 231 || ch == 233) {AddCh(); goto case 2;}
				else if (ch == 'r') {AddCh(); goto case 14;}
				else {t.kind = 1; t.val = new String(tval, 0, tlen); CheckLiteral(); return t;}
			case 13:
				if (ch == '!' || ch >= '%' && ch <= '&' || ch == '+' || ch == '-' || ch >= '/' && ch <= '9' || ch == '=' || ch == '?' || ch >= 'A' && ch <= 'Z' || ch >= '^' && ch <= '_' || ch >= 'a' && ch <= 's' || ch >= 'u' && ch <= 'z' || ch == 163 || ch == 167 || ch == 176 || ch == 231 || ch == 233) {AddCh(); goto case 2;}
				else if (ch == 't') {AddCh(); goto case 15;}
				else {t.kind = 1; t.val = new String(tval, 0, tlen); CheckLiteral(); return t;}
			case 14:
				if (ch == '!' || ch >= '%' && ch <= '&' || ch == '+' || ch == '-' || ch >= '/' && ch <= '9' || ch == '=' || ch == '?' || ch >= 'A' && ch <= 'Z' || ch >= '^' && ch <= '_' || ch >= 'a' && ch <= 'q' || ch >= 's' && ch <= 'z' || ch == 163 || ch == 167 || ch == 176 || ch == 231 || ch == 233) {AddCh(); goto case 2;}
				else if (ch == 'r') {AddCh(); goto case 16;}
				else {t.kind = 1; t.val = new String(tval, 0, tlen); CheckLiteral(); return t;}
			case 15:
				if (ch == '!' || ch >= '%' && ch <= '&' || ch == '+' || ch == '-' || ch >= '/' && ch <= '9' || ch == '=' || ch == '?' || ch >= 'A' && ch <= 'Z' || ch >= '^' && ch <= '_' || ch >= 'a' && ch <= 'd' || ch >= 'f' && ch <= 'z' || ch == 163 || ch == 167 || ch == 176 || ch == 231 || ch == 233) {AddCh(); goto case 2;}
				else if (ch == 'e') {AddCh(); goto case 17;}
				else {t.kind = 1; t.val = new String(tval, 0, tlen); CheckLiteral(); return t;}
			case 16:
				if (ch == '!' || ch >= '%' && ch <= '&' || ch == '+' || ch == '-' || ch >= '/' && ch <= '9' || ch == '=' || ch == '?' || ch >= 'A' && ch <= 'Z' || ch >= '^' && ch <= '_' || ch >= 'a' && ch <= 'n' || ch >= 'p' && ch <= 'z' || ch == 163 || ch == 167 || ch == 176 || ch == 231 || ch == 233) {AddCh(); goto case 2;}
				else if (ch == 'o') {AddCh(); goto case 18;}
				else {t.kind = 1; t.val = new String(tval, 0, tlen); CheckLiteral(); return t;}
			case 17:
				if (ch == '!' || ch >= '%' && ch <= '&' || ch == '+' || ch == '-' || ch >= '/' && ch <= '9' || ch == '=' || ch == '?' || ch >= 'A' && ch <= 'Z' || ch >= '^' && ch <= '_' || ch >= 'a' && ch <= 'q' || ch >= 's' && ch <= 'z' || ch == 163 || ch == 167 || ch == 176 || ch == 231 || ch == 233) {AddCh(); goto case 2;}
				else if (ch == 'r') {AddCh(); goto case 19;}
				else {t.kind = 1; t.val = new String(tval, 0, tlen); CheckLiteral(); return t;}
			case 18:
				if (ch == '!' || ch >= '%' && ch <= '&' || ch == '+' || ch == '-' || ch >= '/' && ch <= '9' || ch == '=' || ch == '?' || ch >= 'A' && ch <= 'Z' || ch >= '^' && ch <= '_' || ch >= 'a' && ch <= 'q' || ch >= 's' && ch <= 'z' || ch == 163 || ch == 167 || ch == 176 || ch == 231 || ch == 233) {AddCh(); goto case 2;}
				else if (ch == 'r') {AddCh(); goto case 20;}
				else {t.kind = 1; t.val = new String(tval, 0, tlen); CheckLiteral(); return t;}
			case 19:
				if (ch == '!' || ch >= '%' && ch <= '&' || ch == '+' || ch == '-' || ch >= '/' && ch <= '9' || ch == '=' || ch == '?' || ch >= 'A' && ch <= 'Z' || ch >= '^' && ch <= '_' || ch >= 'b' && ch <= 'z' || ch == 163 || ch == 167 || ch == 176 || ch == 231 || ch == 233) {AddCh(); goto case 2;}
				else if (ch == 'a') {AddCh(); goto case 21;}
				else {t.kind = 1; t.val = new String(tval, 0, tlen); CheckLiteral(); return t;}
			case 20:
				if (ch == '!' || ch >= '%' && ch <= '&' || ch == '+' || ch == '-' || ch >= '/' && ch <= '9' || ch == '=' || ch == '?' || ch >= 'A' && ch <= 'Z' || ch >= '^' && ch <= '_' || ch >= 'a' && ch <= 'z' || ch == 163 || ch == 167 || ch == 176 || ch == 231 || ch == 233) {AddCh(); goto case 2;}
				else if (ch == ':') {AddCh(); goto case 10;}
				else {t.kind = 1; t.val = new String(tval, 0, tlen); CheckLiteral(); return t;}
			case 21:
				if (ch == '!' || ch >= '%' && ch <= '&' || ch == '+' || ch == '-' || ch >= '/' && ch <= '9' || ch == '=' || ch == '?' || ch >= 'A' && ch <= 'Z' || ch >= '^' && ch <= '_' || ch >= 'a' && ch <= 's' || ch >= 'u' && ch <= 'z' || ch == 163 || ch == 167 || ch == 176 || ch == 231 || ch == 233) {AddCh(); goto case 2;}
				else if (ch == 't') {AddCh(); goto case 22;}
				else {t.kind = 1; t.val = new String(tval, 0, tlen); CheckLiteral(); return t;}
			case 22:
				if (ch == '!' || ch >= '%' && ch <= '&' || ch == '+' || ch == '-' || ch >= '/' && ch <= '9' || ch == '=' || ch == '?' || ch >= 'A' && ch <= 'Z' || ch >= '^' && ch <= '_' || ch >= 'a' && ch <= 'h' || ch >= 'j' && ch <= 'z' || ch == 163 || ch == 167 || ch == 176 || ch == 231 || ch == 233) {AddCh(); goto case 2;}
				else if (ch == 'i') {AddCh(); goto case 23;}
				else {t.kind = 1; t.val = new String(tval, 0, tlen); CheckLiteral(); return t;}
			case 23:
				if (ch == '!' || ch >= '%' && ch <= '&' || ch == '+' || ch == '-' || ch >= '/' && ch <= '9' || ch == '=' || ch == '?' || ch >= 'A' && ch <= 'Z' || ch >= '^' && ch <= '_' || ch >= 'a' && ch <= 'n' || ch >= 'p' && ch <= 'z' || ch == 163 || ch == 167 || ch == 176 || ch == 231 || ch == 233) {AddCh(); goto case 2;}
				else if (ch == 'o') {AddCh(); goto case 24;}
				else {t.kind = 1; t.val = new String(tval, 0, tlen); CheckLiteral(); return t;}
			case 24:
				if (ch == '!' || ch >= '%' && ch <= '&' || ch == '+' || ch == '-' || ch >= '/' && ch <= '9' || ch == '=' || ch == '?' || ch >= 'A' && ch <= 'Z' || ch >= '^' && ch <= '_' || ch >= 'a' && ch <= 'm' || ch >= 'o' && ch <= 'z' || ch == 163 || ch == 167 || ch == 176 || ch == 231 || ch == 233) {AddCh(); goto case 2;}
				else if (ch == 'n') {AddCh(); goto case 25;}
				else {t.kind = 1; t.val = new String(tval, 0, tlen); CheckLiteral(); return t;}
			case 25:
				if (ch == '!' || ch >= '%' && ch <= '&' || ch == '+' || ch == '-' || ch >= '/' && ch <= '9' || ch == '=' || ch == '?' || ch >= 'A' && ch <= 'Z' || ch >= '^' && ch <= '_' || ch >= 'a' && ch <= 'r' || ch >= 't' && ch <= 'z' || ch == 163 || ch == 167 || ch == 176 || ch == 231 || ch == 233) {AddCh(); goto case 2;}
				else if (ch == 's') {AddCh(); goto case 26;}
				else {t.kind = 1; t.val = new String(tval, 0, tlen); CheckLiteral(); return t;}
			case 26:
				if (ch == '!' || ch >= '%' && ch <= '&' || ch == '+' || ch == '-' || ch >= '/' && ch <= '9' || ch == '=' || ch == '?' || ch >= 'A' && ch <= 'Z' || ch >= '^' && ch <= '_' || ch >= 'a' && ch <= 'z' || ch == 163 || ch == 167 || ch == 176 || ch == 231 || ch == 233) {AddCh(); goto case 2;}
				else if (ch == '.') {AddCh(); goto case 11;}
				else {t.kind = 1; t.val = new String(tval, 0, tlen); CheckLiteral(); return t;}

		}
		t.val = new String(tval, 0, tlen);
		return t;
	}
} // end Scanner

